﻿Imports System.Net
Imports System.Security.Cryptography

Public Class Form1

    'This global object will create the license object (required)
    Dim xlic As cumulusgate.services
    'This global object will store the license data across the app from the owner element above (required)
    Dim license As cumulusgate.services.UserLicense

    Private Sub btnLogin_Click(sender As Object, e As EventArgs) Handles btnLogin.Click

        If xlic IsNot Nothing Then
            xlic.CloseLicenseSession()
        End If

        'Check for internet connection and provide grace period if not connected
        If CheckForInternetConnection() = False Then

            'This sample function will return TRUE if grace can be set
            'This sample allows a 1 day grace so if already reached then returns FALSE:
            If SetGrace() = True Then

                'Grace period activated, notify user:

                MsgBox("An internet connection could not be established and a grace license period has been issued. This grace license will only be active for 1 day. Please connect to the internet to avoid licence lock as soon as possible.", vbInformation, "CumulusGate")

            Else

                MsgBox("Grace period cannot be extended / issued, please connect to internet to retrieve a license for this application.", vbCritical, "CumulusGate")

            End If

            Exit Sub

        Else

            'Clear previous Grace data:
            My.Settings.Grace = ""

        End If


        'Create a new instance of the license object (required)
        'usually, the appid will be hardcoded by the developer. For the purposes of this example, we made it a variable so you may test it.
        'A sample application exists with appid = "ABC-DEF-123", you may also wish to create and test your own apps on CumulusGate
        xlic = New cumulusgate.services(txtUser.Text, txtPassw.Text, txtAppId.Text)
        'Return the license details (required)
        license = xlic.ReturnLicenseDetails()

        licPanel.Controls.Clear()

        'All the license properties are exposed below, you can choose which elements you work with

        Dim liclabel_deviceid As New Label
        liclabel_deviceid.Text = "This Computer ID: " & license.strDeviceNode

        licPanel.Controls.Add(liclabel_deviceid)

        Dim liclabel_alreadyactive As New Label
        liclabel_alreadyactive.Text = "Already active on another device: " & license.isAlreadyLoggedIn

        licPanel.Controls.Add(liclabel_alreadyactive)

        'Optional: check if this license is in use on another device (prevent multiple simultaneous usage)
        If license.isAlreadyLoggedIn = True Then

            Dim liclabel_activedeviceid As New Label
            liclabel_activedeviceid.Text = "Server active device ID: " & license.strLoggedNode

            licPanel.Controls.Add(liclabel_activedeviceid)

            Dim liclabel_notify1 As New Label
            liclabel_notify1.Text = "-- Already logged in with another device --"

            licPanel.Controls.Add(liclabel_notify1)

        End If

        'At the core, this is the property that should indicate whether a valid license is found or not
        Dim liclabel_validlicense As New Label
        liclabel_validlicense.Text = "Found Valid License: " & license.gotLicense

        licPanel.Controls.Add(liclabel_validlicense)

        If license.gotLicense = True Then

            Dim liclabel_istrial As New Label
            liclabel_istrial.Text = "In trial: " & license.isTrial

            licPanel.Controls.Add(liclabel_istrial)

            'Optional: Lock the trial license (if present) to the device it was registered to (preventing multiple trial activations on the same account):
            If license.isTrial = True Then

                If license.strDeviceNode <> license.trialNode Then

                    'Set the license to false
                    license.gotLicense = False

                    Dim liclabel_triallocked As New Label
                    liclabel_triallocked.Text = "Trial license locked to another device: " & license.trialNode

                    licPanel.Controls.Add(liclabel_triallocked)

                    For Each ctrl In licPanel.Controls
                        ctrl.AutoSize = True
                    Next

                    Exit Sub

                End If

            End If



            'Check if previous license existed but now expired, perhaps redirect to purchase site (optional, gotLicense property already nullafies any disqualified license criteria)
            Dim liclabel_isexpired As New Label
            liclabel_isexpired.Text = "Has Expired: " & license.isExpired

            licPanel.Controls.Add(liclabel_isexpired)

            Dim liclabel_isenterprise As New Label
            liclabel_isenterprise.Text = "Enterprise license: " & license.isEnterprise

            licPanel.Controls.Add(liclabel_isenterprise)

            'Check if enterprise license is maxxed (quantity in use = total available in bundle)
            If license.isEnterprise = True Then
                Dim liclabel_ismaxxed As New Label
                liclabel_ismaxxed.Text = "Enterprise licenses reached max: " & license.isEnterpriseMaxed

                licPanel.Controls.Add(liclabel_ismaxxed)
            End If

            'Optional, process additional data for single user license
            If license.isEnterprise = False Then

                Dim liclabel_separator1 As New Label
                liclabel_separator1.Text = "----------------------------------------------------------------------------------"

                licPanel.Controls.Add(liclabel_separator1)

                Dim liclabel_expirydate As New Label
                liclabel_expirydate.Text = "Expiry Date: " & license.datExpires

                'Add this date to the "Grace" setting so we can check for license expiry even with no internet connection:
                My.Settings.Grace = EncryptString("online-" & txtAppId.Text & "_" & license.datExpires.Year & "_" & license.datExpires.Month & "_" & license.datExpires.Day & "_0_0_0")


                licPanel.Controls.Add(liclabel_expirydate)

                Dim liclabel_trialexpirydate As New Label
                liclabel_trialexpirydate.Text = "Trial Expiry Date: " & license.datTrialExpires

                licPanel.Controls.Add(liclabel_trialexpirydate)

                Dim liclabel_created As New Label
                liclabel_created.Text = "License Created on: " & license.datcreated_at

                licPanel.Controls.Add(liclabel_created)

                Dim liclabel_notes As New Label
                liclabel_notes.Text = "Customer Notes: " & license.strnotes

                licPanel.Controls.Add(liclabel_notes)

                Dim liclabel_lastaccess As New Label
                liclabel_lastaccess.Text = "Last Access Date: " & license.datlastaccess

                licPanel.Controls.Add(liclabel_lastaccess)

            End If

            Dim liclabel_separator2 As New Label
            liclabel_separator2.Text = "----------------------------------------------------------------------------------"
            licPanel.Controls.Add(liclabel_separator2)

            'Optional, process additional data for enterprise user
            If license.isEnterprise = True Then

                Dim liclabel_entexpirydate As New Label
                liclabel_entexpirydate.Text = "Enterprise Expire Date: " & license.datEntExpires

                'Add this date to the "Grace" setting so we can check for license expiry even with no internet connection:
                My.Settings.Grace = EncryptString("online-" & txtAppId.Text & "_" & license.datEntExpires.Year & "_" & license.datEntExpires.Month & "_" & license.datEntExpires.Day & "_0_0_0")


                licPanel.Controls.Add(liclabel_entexpirydate)

                Dim liclabel_entcreated As New Label
                liclabel_entcreated.Text = "Enterprise License Created on: " & license.datEntCreated_at

                licPanel.Controls.Add(liclabel_entcreated)

                Dim liclabel_entlastaccess As New Label
                liclabel_entlastaccess.Text = "Enterprise Last Accessed: " & license.datEntLastAccess

                licPanel.Controls.Add(liclabel_entlastaccess)

                'The assigned local license admin (useful to users)
                Dim liclabel_entadmin As New Label
                liclabel_entadmin.Text = "Enterprise License Admin: " & license.strEntAdmins

                licPanel.Controls.Add(liclabel_entadmin)

                Dim liclabel_enttotal As New Label
                liclabel_enttotal.Text = "Total Enterprise Licenses: " & license.intEntTotal

                licPanel.Controls.Add(liclabel_enttotal)

                Dim liclabel_entinuse As New Label
                liclabel_entinuse.Text = "Enterprise Licenses In Use: " & license.intEntAccessed

                licPanel.Controls.Add(liclabel_entinuse)

                Dim liclabel_separator3 As New Label
                liclabel_separator3.Text = "----------------------------------------------------------------------------------"
                licPanel.Controls.Add(liclabel_separator3)

            End If

            'Optional, expose the product information
            Dim liclabel_appvendor As New Label
            liclabel_appvendor.Text = "Product Vendor: " & license.strVendor

            licPanel.Controls.Add(liclabel_appvendor)

            Dim liclabel_appname As New Label
            liclabel_appname.Text = "Product Name: " & license.strProduct

            licPanel.Controls.Add(liclabel_appname)

            Dim liclabel_appurl As New Label
            liclabel_appurl.Text = "Product URL: " & license.strUrl

            licPanel.Controls.Add(liclabel_appurl)

            Dim liclabel_licensecycle As New Label
            liclabel_licensecycle.Text = "License Cycle: " & license.strCycle

            licPanel.Controls.Add(liclabel_licensecycle)

            Dim liclabel_isdisabled As New Label
            liclabel_isdisabled.Text = "Is App Disabled: " & license.isDisabled

            licPanel.Controls.Add(liclabel_isdisabled)

            Dim liclabel_defaulttrialduration As New Label
            liclabel_defaulttrialduration.Text = "Trial Duration (days): " & license.intTrialdef

            licPanel.Controls.Add(liclabel_defaulttrialduration)

        Else

            Dim liclabel_nolicense As New Label
            liclabel_nolicense.Text = "-- No valid license found --"

            licPanel.Controls.Add(liclabel_nolicense)

        End If


        For Each ctrl In licPanel.Controls
            ctrl.AutoSize = True
        Next

    End Sub

    Private Sub btnTrial_Click(sender As Object, e As EventArgs) Handles btnTrial.Click

        xlic = New cumulusgate.services(txtUser.Text, txtPassw.Text, txtAppId.Text)
        'Extensive checks will be performed before activating a trial.
        'If a previous license or trial license is found for this user and product (regardless of device), no trial will be acitvated and the user will be notified
        'The same user cannot activate trials multiple times
        If xlic IsNot Nothing Then
            xlic.ActivateTrial()
        End If

    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing

        'Call this function on closing to clear the user's device id data. (required)
        'This will only clear when a valid license was found initially.
        'If this is not done, then subsequent users might be locked out.
        If xlic IsNot Nothing Then
            xlic.CloseLicenseSession()
        End If

    End Sub




    Private Sub btnPassVis_Click(sender As Object, e As EventArgs) Handles btnPassVis.Click

        If txtPassw.PasswordChar = "•" Then
            txtPassw.PasswordChar = ""
            btnPassVis.Image = My.Resources.hide
        Else
            txtPassw.PasswordChar = "•"
            btnPassVis.Image = My.Resources.show
        End If

    End Sub





    'A sample function to handle "grace period" when no internet connection is available:
    Function SetGrace() As Boolean

        'Get the current date and hour
        Dim dateNow As Date = Date.Now
        Dim dnYear As Integer = dateNow.Year
        Dim dnMonth As Integer = dateNow.Month
        Dim dnDay As Integer = dateNow.Day
        Dim dnHour As Integer = dateNow.Hour

        'Check if current grace license is active, if so then get remaining time
        'If no active grace license then create new one
        'If Grace data is empty, then no previous valid license existed (when last connected)
        If My.Settings.Grace.Length > 0 Then

            'Get the Grace data
            Dim strGraceDate As String = DecryptString(My.Settings.Grace)

            'Check if this was while connected or whether it was a grace license
            If strGraceDate.Contains("online-") Then

                'now check if this license would still be active
                strGraceDate = strGraceDate.Replace("online-", "")
                Dim arrLicExp() As String = strGraceDate.Split("_")

                'Check if the App IDs match:
                If txtAppId.Text <> arrLicExp(0) Then
                    Return False
                End If

                'Check if this license is still active
                Dim dateLicExp As New Date(arrLicExp(1), arrLicExp(2), arrLicExp(3), arrLicExp(4), 0, 0)

                'Check remaining time
                Dim spandate As TimeSpan = dateLicExp - Date.Now

                'if expired then return false (no grace)
                If spandate.TotalHours < 1 Then
                    Return False
                End If


                'Create a new temporary grace license
                Dim dateNewExpire As Date = dateNow.AddDays(1)

                Dim dexpNewpYear As Integer = dateNewExpire.Year
                Dim dexpNewMonth As Integer = dateNewExpire.Month
                Dim dexpNewDay As Integer = dateNewExpire.Day
                Dim dexpNewHour As Integer = dateNewExpire.Hour

                Dim strGrace As String = txtAppId.Text & "_" & dexpNewpYear & "_" & dexpNewMonth & "_" & dexpNewDay & "_" & dexpNewHour

                'encrypt this string and save to settings
                My.Settings.Grace = EncryptString(strGrace)
                My.Settings.Save()

            End If


            'Split the data
            Dim arrGraceData() As String = strGraceDate.Split("_")

            'Process the date data
            Dim dexpYear As Integer = arrGraceData(1)
            Dim dexpMonth As Integer = arrGraceData(2)
            Dim dexpDay As Integer = arrGraceData(3)
            Dim dexpHour As Integer = arrGraceData(4)

            Dim dateExpire As Date = New Date(dexpYear, dexpMonth, dexpDay, dexpHour, 0, 0)

            'Now check if the date has expired
            Dim dateSpan As TimeSpan = dateExpire - Date.Now

            If dateSpan.TotalHours > 0 Then
                'If in Grace license mode, hours will be less than 25 hours so check and report if true
                If dateSpan.TotalHours < 25 Then
                    MsgBox(Math.Round(dateSpan.TotalHours, 0) & " Hours remaining on current Grace License.", vbInformation, "CumulusGate")
                End If
                Return True
            Else
                Return False
            End If

        Else

            'No previous valid license existed
            Return False

        End If

    End Function


    'Encrypt string

    Public Shared Function EncryptString(Message As String) As String
        Dim Results As Byte()
        Dim UTF8 As New System.Text.UTF8Encoding()
        Dim HashProvider As New MD5CryptoServiceProvider()
        Dim TDESKey As Byte() = HashProvider.ComputeHash(UTF8.GetBytes("ABC123"))
        Dim TDESAlgorithm As New TripleDESCryptoServiceProvider()
        TDESAlgorithm.Key = TDESKey
        TDESAlgorithm.Mode = CipherMode.ECB
        TDESAlgorithm.Padding = PaddingMode.PKCS7
        Dim DataToEncrypt As Byte() = UTF8.GetBytes(Message)
        Try
            Dim Encryptor As ICryptoTransform = TDESAlgorithm.CreateEncryptor()
            Results = Encryptor.TransformFinalBlock(DataToEncrypt, 0, DataToEncrypt.Length)
        Finally
            TDESAlgorithm.Clear()
            HashProvider.Clear()
        End Try
        Return Convert.ToBase64String(Results)
    End Function

    'Decrypt string

    Public Shared Function DecryptString(Message As String) As String
        Dim Results As Byte()
        Dim UTF8 As New System.Text.UTF8Encoding()
        Dim HashProvider As New MD5CryptoServiceProvider()
        Dim TDESKey As Byte() = HashProvider.ComputeHash(UTF8.GetBytes("ABC123"))
        Dim TDESAlgorithm As New TripleDESCryptoServiceProvider()
        TDESAlgorithm.Key = TDESKey
        TDESAlgorithm.Mode = CipherMode.ECB
        TDESAlgorithm.Padding = PaddingMode.PKCS7
        Dim DataToDecrypt As Byte() = Convert.FromBase64String(Message)
        Try
            Dim Decryptor As ICryptoTransform = TDESAlgorithm.CreateDecryptor()
            Results = Decryptor.TransformFinalBlock(DataToDecrypt, 0, DataToDecrypt.Length)
        Finally
            TDESAlgorithm.Clear()
            HashProvider.Clear()
        End Try
        Return UTF8.GetString(Results)
    End Function


    'Sample function to check internet access:

    Public Function CheckForInternetConnection() As Boolean

        'Override to simulate "no internet"
        If cbInternet.Checked = True Then
            Return False
        End If


        'Check for internet connection
        Try
            Using client = New WebClient()
                Using stream = client.OpenRead("http://www.google.com")
                    Return True
                End Using
            End Using
        Catch
            Return False
        End Try
    End Function

    'This demonstrates how to use the CumulusUpdate service. You'll first need to publish updates via the CumulusUpdate Desktop Manager,
    'available from https://cumulusgate.com 

    Private Sub btnUpdate_Click(sender As Object, e As EventArgs) Handles btnUpdate.Click

        'Let's create a text file that contains the current version (if not already present),
        'We'll use this to compare with the web version:
        If My.Computer.FileSystem.FileExists(Application.StartupPath() & "\currver.txt") = False Then
            IO.File.WriteAllText(Application.StartupPath() & "\currver.txt", "0.0.0")
        End If

        'Initialize a new instance of the Update class:
        Dim xUpdate As New cumulusgate.CumulusUpdate(txtAppId.Text)

        'Get info on the current server version:
        lblUpdate.Text = xUpdate.returnCurrentWebVersion()

        'Let's store the versions for current and new:
        Dim strCurrVer As String = IO.File.ReadAllText(Application.StartupPath() & "\currver.txt")
        Dim strNewVer As String = lblUpdate.Text

        'Check if there is a web version ("N/A" means no web version),
        'Also check if the current version is different to the web version:
        If strCurrVer <> strNewVer And strNewVer <> "N/A" Then

            'Ask the user whether to download this version (optionally add additional version checks):
            Dim result As DialogResult = MessageBox.Show("Would you like to download version: " & lblUpdate.Text & "?", "Cumulus Update", MessageBoxButtons.YesNo)
            If result = DialogResult.Yes Then

                'Let's create some folders that we will require later on, if they do not already exist:
                If My.Computer.FileSystem.DirectoryExists(Application.StartupPath() & "\updates") = False Then
                    My.Computer.FileSystem.CreateDirectory(Application.StartupPath() & "\updates")
                End If
                'and:
                If My.Computer.FileSystem.DirectoryExists(Application.StartupPath() & "\update_test") = False Then
                    My.Computer.FileSystem.CreateDirectory(Application.StartupPath() & "\update_test")
                End If

                'Download the server package and display progress real-time:
                '("lblUpdate" is a label that we can pass onto the function to return real-time status info)
                '("Me" is this form, so we can trigger a refresh after each label update)
                Dim strResult As String = xUpdate.downloadUpdate(Application.StartupPath() & "\updates", lblUpdate, Me)

                'If the download was successful, close this app (to free resources) and initialize a post-process app to unpack the downloaded archive:
                If strResult = "Success" Then

                    'Handle post-processing here:

                    ' Create a new ProcessStartInfo
                    Dim p As New ProcessStartInfo

                    ' Specify the location of the post process executable:
                    p.FileName = Application.StartupPath() & "\CumulusUpdate_Post_Sample_VB.exe"

                    ' Use these 4 arguments for the process:

                    'Source Zip file:
                    Dim strSourcefile As String = xUpdate.returnZipFilePath()
                    'Destination folder to extract to:
                    Dim strDestinationFolder As String = Application.StartupPath() & "\update_test"
                    'Application to restart after update (could be your executable or host executable for add-ins):
                    Dim strAppToRestart As String = Application.StartupPath() & "\CumulusGate_VB_Sample.exe"
                    'Windows process to wait for before updating (could be your executable or host executable for add-ins, example "Revit.exe"):
                    Dim strProcessFinish As String = "CumulusGate_VB_Sample.exe"

                    'Add parentheses (Chr(34)) to close off spaces in path strings,
                    'The full path with arguments should be: "path to updater executable" "source zip file" destination root folder path" "application to restart path" "process to finish name" new version":
                    p.Arguments = Chr(34) & strSourcefile & Chr(34) & " " & Chr(34) & strDestinationFolder & Chr(34) & " " & Chr(34) & strAppToRestart & Chr(34) & " " & Chr(34) & strProcessFinish & Chr(34) & strNewVer & Chr(34)

                    ' Start the process
                    Process.Start(p)

                    ' Close this app:
                    Me.Close()


                End If

            ElseIf result = DialogResult.No Then
                MessageBox.Show("Operation Cancelled")
            End If

        End If

    End Sub
End Class
