﻿Imports System.IO
Imports System.IO.Compression

Public Class Form1

    Dim strProcName As String
    Dim strVer As String

    Sub New()

        Dim args As String() = Environment.GetCommandLineArgs()

        InitializeComponent()

        'Check that commandline arguments are valid:
        If My.Computer.FileSystem.FileExists(args(1)) = True And My.Computer.FileSystem.DirectoryExists(args(2)) = True And args.Count = 6 Then
            txtSrc.Text = args(1)
            txtDest.Text = args(2)
            txtAppPath.Text = args(3)
            strProcName = args(4)
            strVer = args(5)
            lblProc.Text = strProcName

            Me.Text = Me.Text & ": Ver." & strVer

            'Now that we have the paths, check whether the previous process stopped completely using a timer:
            tmrProc.Start()
        Else
            txtSrc.Text = "All paths not valid"
            btnUpdate.Enabled = False
        End If


    End Sub

    Private Sub btnUpdate_Click(sender As Object, e As EventArgs) Handles btnUpdate.Click
        'Extract the archive to the destination folder,
        'Create new folders if they do not already exist in the root directory:
        Using archive As ZipArchive = ZipFile.OpenRead(txtSrc.Text)
            For Each entry As ZipArchiveEntry In archive.Entries
                If My.Computer.FileSystem.DirectoryExists(IO.Path.GetDirectoryName(Path.Combine(txtDest.Text, entry.FullName))) = False Then
                    My.Computer.FileSystem.CreateDirectory(IO.Path.GetDirectoryName(Path.Combine(txtDest.Text, entry.FullName)))
                End If

                entry.ExtractToFile(Path.Combine(txtDest.Text, entry.FullName), True)
            Next
        End Using

        MsgBox("Done!" & vbNewLine & "Restarting Application: " & IO.Path.GetFileNameWithoutExtension(txtAppPath.Text))
        'Restart the original application:
        Process.Start(txtAppPath.Text)
        'Write the web version to a text file so we can compare next time the original app starts:
        IO.File.WriteAllText(Application.StartupPath() & "\currver.txt", strVer)
        Close()
    End Sub

    Dim p() As Process


    Private Sub tmrProc_Tick(sender As Object, e As EventArgs) Handles tmrProc.Tick

        p = Process.GetProcessesByName(IO.Path.GetFileNameWithoutExtension(strProcName))
        If p.Count > 0 Then
            btnUpdate.Enabled = False
        Else
            tmrProc.Stop()
            lblProc.Text = strProcName & "-Finished"
            btnUpdate.Enabled = True
        End If

    End Sub

End Class
